//Anachronox DAT File Extractor Version 2
// by John Rittenhouse
// cryect@captured.com
// Updated  7/1/2001
// Original 6/30/2001
//
// You may use this source just give me credit.  I'm not having it bundled up with the GNU
// so you don't have to release your source code on demand.  But do please give back to the
// community. Oh part of this is based off DarkYoda's file loading code(I thought his worked
// better than the code I was using so I decided to borrow his for this program =)
//
// Updated on 7/1/2001(American Dates not European) I fixed a couple of memory leaks and 
// Removed some code that didn't need to be there.  Basically most things were minor.


#include			<windows.h>
#include			<stdio.h>
#include			<conio.h>
#include			<assert.h>
#include			<direct.h>
#include			<iostream.h>
#include			<fstream.h>

#define _WINDOWS 
#define ZLIB_DLL 
#include			<zlib.h>

#include			"dat.h"

char				Filename[512];
char				Directory[512];
char				Direct[512];

fstream				FileStream;
DATHeader			*FileHeader;
FileInfo			*Files;
int					NumFiles;

int					CurrentFileNum=0;
int					Quit=0;

//
// OpenDialog
//
int LoadDialog( char *inTitle, char *inFilter )
{
	OPENFILENAME    OpenFileName;

	OpenFileName.lStructSize       = sizeof(OPENFILENAME);     
	OpenFileName.hwndOwner         = GetFocus( );    
	OpenFileName.hInstance         = GetModuleHandle( NULL );   
	OpenFileName.lpstrFilter       = inFilter;    
	OpenFileName.lpstrCustomFilter = (LPTSTR) NULL;   
	OpenFileName.nMaxCustFilter    = 0L;    
	OpenFileName.nFilterIndex      = 1L;    
	OpenFileName.lpstrFile         = Filename; 
    OpenFileName.nMaxFile          = 512; 
    OpenFileName.lpstrFileTitle    = NULL;  
	OpenFileName.nMaxFileTitle     = 0;   
	OpenFileName.lpstrInitialDir   = NULL;    
	OpenFileName.lpstrTitle        = inTitle; 
	OpenFileName.nFileOffset       = 0;   
	OpenFileName.nFileExtension    = 0;  
	OpenFileName.lpstrDefExt       = NULL; // No default extension     
	OpenFileName.lCustData         = 0;     
	OpenFileName.Flags =	OFN_SHOWHELP | OFN_PATHMUSTEXIST |                          
							OFN_FILEMUSTEXIST | OFN_HIDEREADONLY |                          
							OFN_EXPLORER | OFN_LONGNAMES;        
	
	return (GetOpenFileName(&OpenFileName));
}

void OpenFile()
{
	//
	// Safe Read File
	//
	assert( Filename );

	printf( "Loading File %s ...\n\n", Filename );

	FILE		*fp;
	DWORD		size;
	
	fp = fopen( Filename, "rb" );
	FileStream.open(Filename,ios::in|ios::binary);

	if( !FileStream.is_open() )
	{
		printf( "ERROR : Unable to Open Specified File %s\n", Filename );
		exit(0);
	}
	
	FileStream.seekp(0,ios::end);
	size=FileStream.tellp();
	FileStream.seekp(0,ios::beg);


	assert( size );




	//Setup Pointers
	FileHeader=new DATHeader;

	assert(FileHeader);

	FileStream.read((char *)FileHeader,sizeof(DATHeader));

	//Check To make sure its a dat file
	if((FileHeader->ID[0]!='A')||(FileHeader->ID[1]!='D')||(FileHeader->ID[2]!='A')||(FileHeader->ID[3]!='T'))
	{
		printf( "ERROR : File %s is not a DAT file\n", Filename );
		delete FileHeader;
		FileStream.close();
		exit(0);
	}

	NumFiles=FileHeader->FLength/144;

	Files = new FileInfo[NumFiles];

	assert( Files);

	FileStream.seekp(FileHeader->FInfoPos,ios::beg);
	FileStream.read((char *)Files,FileHeader->FLength);

	
}
void WriteFile(int FileNum)
{
	//
	// Safe Write File
	//
	char *File;
	

	printf( "Writing File #%i %s ...\n", FileNum,Files[FileNum].FileName );

	
	fstream		OutFile;

	OutFile.open(Files[FileNum].FileName, ios::out|ios::binary);

	if( !OutFile.is_open() )
	{
		printf( "ERROR : Unable to Open Specified File %s\n", Files[FileNum].FileName );
		FileStream.close();
		delete FileHeader;
		delete Files;
		exit(0);
	}

	File=new char[Files[FileNum].Length];

	FileStream.seekp(Files[FileNum].StartPos,ios::beg);
	
	FileStream.read(File,Files[FileNum].Length);

	
	OutFile.write(File,Files[FileNum].Length);
	OutFile.close();
	delete File;
}

void WriteCompressedFile(int FileNum)
{
	//
	// Safe Write File
	//
	printf( "Writing Compressed File #%i %s ...\n", FileNum,Files[FileNum].FileName );


	fstream		OutFile;

	OutFile.open(Files[FileNum].FileName, ios::out|ios::binary);

	if( !OutFile.is_open() )
	{
		printf( "ERROR : Unable to Open Specified File %s\n", Files[FileNum].FileName );
		FileStream.close();
		delete FileHeader;
		delete Files;
		exit(0);
	}

	unsigned char *Input,*Output;
	Input = new unsigned char[Files[FileNum].Compressed];
	Output=new unsigned char[Files[FileNum].Length];
	
	FileStream.seekp(Files[FileNum].StartPos,ios::beg);
	
	FileStream.read(Input,Files[FileNum].Compressed);

	//Uncompress the file
	int t;
	t=uncompress(Output,&Files[FileNum].Length,Input,Files[FileNum].Compressed);

	if(t==-3)//Bad data
	{
		printf( "ERROR : Bad Compressed Data for File %s\n", Files[FileNum].FileName );
		FileStream.close();
		delete FileHeader;
		delete Files;
		delete Output;
		delete Input;
		exit(0);
	}

	
	//Write the decompressed file out
	OutFile.write(Output,Files[FileNum].Length);
	OutFile.close();
	delete Output;
	delete Input;
}
void DisplayFileInfo(int FileNum)
{
	printf("%i %s %i bytes \n",FileNum+1,Files[FileNum].FileName,Files[FileNum].Length);
}

void CreateDirectories(char *Dir)
{
	
	int DirPos=0,i;

	
	i=1;
	while((Dir[i]!=0)&&(Dir[i]!='\\'))
		i++;
	//Otherwise its just a plain ordinary file if it only has it at the front
	if(Dir[i]!=0)
	{
		Dir[i]=0;
		//add the additional directory on to the current directory
		strcat(Direct,"\\");
		strcat(Direct,Dir);

		if(!mkdir(Dir))
			printf("Made the directory %s \n",Direct);
		chdir(&Direct[2]);
		
		Dir[i]='\\';
		
		CreateDirectories(&Dir[i+1]);
		
	}

}
/*
//No Longer needed because FStream supports spaces in filenames
void FixFileName(int FileNum)
{
	int i=0;
	while(Files[FileNum].FileName[i]!=0)
	{
		if(Files[FileNum].FileName[i]==' ')
			Files[FileNum].FileName[i]='_';
		i++;
	}
}

void FixFileNames()
{
	for(int i=0;i<NumFiles;i++)
		FixFileName(i);
}*/

void WriteTheFile(int FileNum)
{
	//First create the directories if need be
	
	//First Change the Drive and directory to where it should be
	_chdrive( toupper( Directory[0] ) - 'A' + 1 );
	_chdir(&Directory[2]);
	_getdcwd(toupper( Directory[0] ) - 'A' + 1, Direct, 512);
	//Create the directory
	CreateDirectories(Files[FileNum].FileName);

	_chdir(&Directory[2]);
	//Write the file now
	if(!Files[FileNum].Compressed)
		WriteFile(FileNum);
	else
		WriteCompressedFile(FileNum);
}

void DisplayFiles()
{
	for(int i=0;(i<20)&&((i+CurrentFileNum)<NumFiles);i++)
		DisplayFileInfo(i+CurrentFileNum);
}

void ExtractFile()
{
	int i;
	printf("Which file number do you wish to extract? ");
	cin>>i;

	if((i<1)||(i>NumFiles))
	{
		printf("Illegal File Number\n");
		return;
	}

	WriteTheFile(i-1);
}

void UI()
{
	int KeyHit;
start:
	DisplayFiles();

	//Get Key
	KeyHit=getch();
	


	if(KeyHit==27)//Escape
		return;//Quit then
	else if(KeyHit==32)//SpaceBar
		for(int i=0;i<NumFiles;i++)//Extract all files
			WriteTheFile(i);
	else if(KeyHit==72)//Up Arrow
	{
		CurrentFileNum-=20;
		if(CurrentFileNum<0)
			CurrentFileNum=0;
	}
	else if(KeyHit==80)
	{
		CurrentFileNum+=20;
		if(CurrentFileNum>=NumFiles)
			CurrentFileNum=NumFiles-20;
	}
	else if(KeyHit==13)
		ExtractFile();

	goto start;
		
}
void main(int argc, char *argv[ ])
{
	printf("Anachronox DAT File Extractor Version 2\n");
	printf(" by John Rittenhouse\n");
	printf(" cryect@captured.com\n");
	printf(" 6/30/2001(Updated 7/1/2001)\n\n");
	if( argc < 2 )
	{
		if(!LoadDialog( "Load .dat", "Anachronox DAT Files (*.dat)\0*.dat\0All Files<bad idea>(*.*)\0*.*\0\0" ))
			return;
	}
	else
	{
		strcpy( Filename, argv[1] );
	}

	//Put down the directory
	int p=0,dp=0;
	strcpy(Directory,Filename);
	while(Directory[p]!=0)
	{
		if(Directory[p]=='\\')
			dp=p;
		p++;
	}
	if(dp!=0)
		Directory[dp]=0;




	OpenFile();
	UI();

	FileStream.close();
	delete FileHeader;
	delete Files;
}